/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;
import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import com.ibm.samplegallery.WebappResources;
import com.ibm.samplegallery.internal.*;
/*
 * handles requests for the tree menu rendering
 */
public class GalleryMenuController extends HttpServlet implements GalleryConstants {
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1)
		throws ServletException, IOException {
		this.processRequest(arg0, arg1);
	}
	
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest arg0, HttpServletResponse arg1)
		throws ServletException, IOException {
		this.processRequest(arg0, arg1);
	}
	
	private void processRequest(HttpServletRequest req, HttpServletResponse resp) throws IOException {
		LayoutData data = new LayoutData(req, resp);
		
		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		StringBuffer html = new StringBuffer();
		html.append("<html>\n"); //$NON-NLS-1$
		html.append("<head>\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n"); //$NON-NLS-1$
		html.append("<META http-equiv=\"Pragma\" content=\"no-cache\">\n"); //$NON-NLS-1$
		html.append("<META http-equiv=\"Expires\" content=\"0\">\n"); //$NON-NLS-1$
		html.append("<META http-equiv=\"Cache-Control\" content=\"no-cache\">\n"); //$NON-NLS-1$
		html.append("<style type=\"text/css\">\n"); //$NON-NLS-1$
		html.append("FRAMESET {\n"); //$NON-NLS-1$
		html.append("border-top:1px solid ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("border-left:1px solid ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("border-right:1px solid ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("</style>\n"); //$NON-NLS-1$
		html.append("<script language=\"JavaScript\">\n"); //$NON-NLS-1$
		html.append("function showView(view)\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("treeNav.showView(view);\n"); //$NON-NLS-1$
		html.append("sgtabs.showTab(view);\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("</script>\n"); //$NON-NLS-1$
		html.append("</head>\n"); //$NON-NLS-1$
		html.append("<FRAMESET rows=\"*,32\" frameborder=\"0\" framespacing=\"0\" border=0 spacing=0>\n"); //$NON-NLS-1$
		html.append("<FRAME src=\"GalleryNavigatorController" + data.getQuery() + "\" name=\"treeNav\" frameborder=\"NO\" resize=\"yes\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"no\" title=\"" + WebappResources.getString(I18N.GALLERY_FRAME_LAYOUT) + "\">\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("<FRAME src=\"GalleryTabs\" name=\"sgtabs\" title=\"" + WebappResources.getString(I18N.GALLERY_FRAME_TABS) + "\" frameborder=\"NO\" noresize resize=\"no\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"no\">\n"); //$NON-NLS-1$
		html.append("</FRAMESET>\n"); //$NON-NLS-1$
		html.append("<body onload=\"showView('toc')\">\n"); //$NON-NLS-1$
		html.append("</body>\n"); //$NON-NLS-1$
		html.append("</html>\n"); //$NON-NLS-1$
		String htmlString = html.toString();
		resp.getWriter().println(htmlString);
	}
}
