/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.samplegallery.WebappResources;
import com.ibm.samplegallery.internal.GalleryConstants;
import com.ibm.samplegallery.internal.LayoutData;

/**
 * Class defining the main framesets. 
 * 
 */
public class SampleGalleryController extends HttpServlet implements GalleryConstants {

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
		this.processRequest(req, resp);
	}
	
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
		throws ServletException, IOException {
		this.processRequest(req, resp);
	}
	
	public void processRequest(HttpServletRequest req, HttpServletResponse resp)
	throws ServletException, IOException {
		LayoutData data = new LayoutData(req, resp);
		
		StringBuffer html = new StringBuffer();
		html.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\">\n"); //$NON-NLS-1$
		html.append("<!------------------------------------------------------------------------------\n"); //$NON-NLS-1$
		html.append(" ! Copyright (c) 2000, 2003 IBM Corporation and others.\n"); //$NON-NLS-1$
		html.append(" ! All rights reserved.\n"); //$NON-NLS-1$
		html.append(" ------------------------------------------------------------------------------->\n"); //$NON-NLS-1$
		html.append("<html>\n"); //$NON-NLS-1$
		html.append("<head>\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"content-type\" content=\"text/html;charset=iso-8859-1\">\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Expires\" content=\"0\">\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Cache-Control\" content=\"no-cache\">\n"); //$NON-NLS-1$
		
		html.append("<title>" + WebappResources.getString(I18N.GALLERY_TITLE) + "</title>\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("</head>\n"); //$NON-NLS-1$
		//html.append("<frameset rows=\"53,*\" frameborder=\"yes\" bordercolor=\"#CCCCCCC\" >\n");
		//html.append("<frame colspan=\"2\" src=\"" + data.getGalleryTitleURL() + "\" name=\"banner\" noresize scrolling=\"NO\" frameborder=\"NO\" marginwidth=\"0\" marginheight=\"0\" title=\"Banner\">\n");
		
		html.append("<frameset\n" +
				"style=\"border-top: 4px solid ButtonFace;\"\n" +
				"style=\"border-right: 4px solid ButtonFace;\"\n" +
				"style=\"border-bottom: 4px solid ButtonFace;\"\n" +
				"style=\"border-left: 4px solid ButtonFace;\"\n" +
				"id=\"sampleFrameset\" cols=\"29.5%,70.5%\" framespacing=\"3\" border=\"6\"  frameborder=\"1\"   scrolling=\"no\">\n" +
				"<frame src=\"GalleryMenu" + data.getQuery() + "\" name=\"nav\" title=\"Menu\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"no\" frameborder=\"1\" resize=yes>\n" +
				"<frame src=\"GalleryContentController" + data.getQuery() + "\" name=\"content\" title=\"Samples Content Area\" class=\"content\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"no\" frameborder=\"0\" resize=yes>\n" +
				"</frameset>\n");
		
		// html.append("<frameset cols=\"23%,*\" frameborder=\"yes\" bordercolor=\"#CCCCCC\">\n"); //$NON-NLS-1$
		// html.append("<frame src=\"GalleryMenu" + data.getQuery() + "\" name=\"nav\" frameborder=\"no\" border=\"0\" resize=\"yes\" marginwidth=\"0\" marginheight=\"0\" scrolling=\"auto\" title=\"Menu\">\n"); //$NON-NLS-1$ //$NON-NLS-2$
		// html.append("<frame src=\"GalleryContentController" + data.getQuery() + "\" name=\"content\" frameborder=\"no\" border=\"0\" marginwidth=\"5\" marginheight=\"0\" resize=\"yes\" title=\"Samples Content Area\">\r\n"); //$NON-NLS-1$ //$NON-NLS-2$
		// html.append("</frameset>\n"); //$NON-NLS-1$
		//html.append("</frameset>\n");
		html.append("<noframes>" + WebappResources.getString(I18N.GALLERY_NOFRAMES) + "</noframes>\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("</html>\n"); //$NON-NLS-1$
		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		String htmlString = html.toString();
		resp.getWriter().println(htmlString);
	}
}
