// *******************************************************************************
// Copyright (c) 2004, 2005 IBM Corporation and others.
// All rights reserved. 
// *******************************************************************************
 
var openImg = new Image();
openImg.src = "topic/com.ibm.gallery.common/images/minus.gif";
var closedImg = new Image();
closedImg.src = "topic/com.ibm.gallery.common/images/plus.gif";
var openFolders = new Array();

// Common scripts for IE and Mozilla.
var isMozilla = navigator.userAgent.indexOf('Mozilla') != -1 && parseInt(navigator.appVersion.substring(0,1)) >= 5;
var isIE = navigator.userAgent.indexOf('MSIE') != -1;

// selected node
var active;
var oldActive;

function highlightTopic(topic){
  	if (!topic || (topic.tagName != "A")){
		return false;
	}
	if (oldActive) {
		if(oldActive.parentNode.className=="branch") {
			oldActive.className="";
		} else if (oldActive.parentNode.className=="leaf") {
    		oldActive.className="";
    	}
    }
    if(topic.parentNode.className=="branch") {
    	topic.className="active";
    	oldActive = topic;
    } else if (topic.parentNode.className=="leaf") {
    	topic.className="active";
    	oldActive = topic;
    } else {
    }
    return true;
}

function tree(){
	this.branches = new Array();
	this.add = addBranch;
	this.write = writeTree;
	this.selectedItemID="";
	this.setSelection = setSelection;
}

function branch(id, icon, text, link, expanded){
	this.id = id;
	this.icon = icon;
	this.text = text;
	this.link = link;
	this.write = writeBranch;
	this.add = addLeaf;
	this.leaves = new Array();
	this.parentID = "";
	this.isExpanded=expanded;
	if(expanded=="true") {
		openFolders[openFolders.length] = id;
	}
}

function leaf(id, text, link){
	this.id = id;
	this.text = text;
	this.link = link;
	this.write = writeLeaf;
	this.parentID = "";
}

function setSelection(sampleID) {
	this.selectedItemID = sampleID;
}

function writeTree(){
	var treeString = '';
	treeString += '<tr><td class="nav" nowrap>';
	var numBranches = this.branches.length;
	for(var i=0;i<numBranches;i++){
		treeString += this.branches[i].write();
	}
	treeString += '</tr></td>';
	document.write(treeString);
	updateOpenFolders();
	if(this.selectedItemID != "") {
		var selectedItem = document.getElementById('H' + this.selectedItemID);
		selectedItem.focus();
		highlightTopic(selectedItem);
	}
	document.close();
}

function addBranch(branch){
	this.branches[this.branches.length] = branch;
	branch.parentID = this.id;
}

function writeBranch(){
	var numLeaves = this.leaves.length;
	var branchString = '<span class="branch">';
	
	if(numLeaves>0){
		// Branch has something below it, add plus icon
		branchString += '<img class="nav" onClick="updateBranch(\'' + this.id + '\')" WIDTH="16" HEIGHT="16" src="/SampleGallery/topic?file=com.ibm.gallery.common/images/plus.gif" alt="' + altTopicClosed + '" id="I' + this.id + '">';
	} else {
		branchString += '<img class="nav" WIDTH="16" HEIGHT="16" src="/SampleGallery/topic?file=com.ibm.gallery.common/images/empty_branch.gif">';
	}
	// Add category icon
	if (this.icon != "null"){
		// Icon was specified
		branchString += '<img class="nav" src="images/' + this.icon + '" width="16" height="16">';
	} else {
		// Use default icon
		branchString += '<img class="nav" src="images/samples_obj.gif" width="16" height="16" >';
	}
	
	if(numLeaves>0){
		// Branch has something below it, onClick expands tree
		branchString += '<a class="nav" onClick="updateDeapBranch(this)"  href="'+ this.link +'" target="Main" id="H' + this.id + '">';
	} else {
		branchString += '<a class="nav" onClick="highlightTopic(this)" href="'+ this.link +'" target="Main" id="H' + this.id + '">';
	}
	branchString += '<NOBR>';
	// If the category is one of main three, bold it
	if (this.parentID == null){
		branchString += '<B>';
	}
	// Add text for link
	branchString += this.text;
	// Close bold, if needed
	if (this.parentID == null){
		branchString += '</B>';
	}
	branchString += '</NOBR>';
	branchString += '</a>';
	branchString += '</span>';
	branchString += '<span class="leaf" id="';
	branchString += this.id + '">';
	for(var j=0;j<numLeaves;j++){
		branchString += this.leaves[j].write();
	}
	branchString += '</span>';
	return branchString;
}

function addLeaf(leaf){
	this.leaves[this.leaves.length] = leaf;
	leaf.parentID = this.id;
}

function writeLeaf(){
	var leafString = '<img class="nav" WIDTH="16" HEIGHT="16" src="/SampleGallery/topic?file=com.ibm.gallery.common/images/clear.gif">';
	leafString += '<img class="nav" WIDTH="16" HEIGHT="16" src="topic/com.ibm.gallery.common/images/sample_obj.gif">';
	leafString += '<a class="nav" onClick="highlightTopic(this)" href="' + this.link + '" target="Main" id="H' + this.id + '">';
	leafString += this.text;
	leafString += '</a><br>';
	return leafString;
}

function updateOpenFolders() {
	var numOpenFolders = openFolders.length;
	for(var i=0;i<numOpenFolders;i++) {
		openBranch(openFolders[i]);
	}
}

function openBranch(branch){
	var objBranch = document.getElementById(branch).style;
	objBranch.display="block";
	objImg = document.getElementById('I' + branch);
	objImg.src = openImg.src;
	objImg.alt = altTopicOpen;
}

function closeBranch(branch){
	var objBranch = document.getElementById(branch).style;
	objBranch.display="none";
	objImg = document.getElementById('I' + branch);
	objImg.src = closedImg.src;
	objImg.alt = altTopicClosed;
}

function updateDeapBranch(node){
	highlightTopic(node);
	updateBranch(getBaseID(node));
}

function updateBranch(branch){
	var objBranch = document.getElementById(branch).style;
	if(objBranch.display=="block"){
		objBranch.display="none";
	} else {
		objBranch.display="block";
	}
	updateFolderImage('I' + branch);
}

function updateFolderImage(img){
	objImg = document.getElementById(img);
	if(objImg.src.indexOf('plus.gif')>-1){
		objImg.src = openImg.src;
		objImg.alt = altTopicOpen;
	}
	else {
		objImg.src = closedImg.src;
		objImg.alt = altTopicClosed;
	}
}

/**
 * Handler for key down (arrows)
 */
function keyDownHandler(e)
{
	var key;
	if (isIE) {
		key = window.event.keyCode;
	} else if (isMozilla) {
		key = e.keyCode;
	}	
	if (key <37 || key > 40) {
		return true;
	}
	if (isMozilla)
  		e.cancelBubble = true;
  	else if (isIE)
  		window.event.cancelBubble = true;		
  	if (key == 39) { // Right arrow, expand
		var clickedNode = getTarget(e);	
  		if (!clickedNode) return;

  		if(isCollapsedFolder(clickedNode)) {
			var baseID = getBaseID(clickedNode);
			openBranch(baseID);
			highlightTopic(clickedNode);
  			scrollIntoView(clickedNode);
		}
  	} else if (key == 37) { // Left arrow,collapse
		var clickedNode = getTarget(e);
  		if (!clickedNode) return;

		if(isExpandedFolder(clickedNode)) {
			var baseID = getBaseID(clickedNode);
			closeBranch(baseID);
			highlightTopic(clickedNode);
  			scrollIntoView(clickedNode);
		}
  	} else if (key == 40 ) { // down arrow
  		var clickedNode = getTarget(e);
  		if (!clickedNode) return;

		var next = getNextDown(clickedNode);
		if (next)
			next.focus();

  	} else if (key == 38 ) { // up arrow
  		var clickedNode = getTarget(e);
  		if (!clickedNode) return;

		var next = getNextUp(clickedNode);
		if (next)
			next.focus();
  	}	
  	return false;
}

/**
 * Returns the next tree node "up" from current one
 */
function getNextUp(node){
	var up = null;
	var sibling = getPreviousSibling(node);
	if (sibling != null) {
		// try to get the deepest node that preceeds this current node
		var candidate = getDescendantNode(sibling, "A");
		var nextDown = getNextDown(candidate);
		while(nextDown != null && nextDown != node){
			candidate = nextDown;
			nextDown = getNextDown(nextDown);
		}
		return getDescendantNode(candidate, "A");
	} else {
		up = getParent(node);
	}
	return up;
}

/**
 * Returns the next tree node "down" from current one
 */
function getNextDown(node){	
	// If expanded folder, return first child.
	if(isExpandedFolder(node)) {
		var baseID = getBaseID(node);
		var objBranch = document.getElementById(baseID)
		return getDescendantNode(objBranch, "A")
	}
	
	// Try next sibling
	var sibling = getNextSibling(node);
	if (sibling != null) {
		return getDescendantNode(sibling, "A");
	}

	var parent = node;
	// Try looking to parent's sibling
	while(sibling == null) {
		parent = getParent(parent);
		if (!parent) // reached the top, nothing else to do
			return null;

		sibling = getNextSibling(parent);		
	}
	return sibling;
}

/**
 * Returns the next parent element
 */
function getParent(anode) {
	var parent = null;
	if(anode.parentNode.className == "leaf") {
		var spanparent = anode.parentNode.previousSibling;
		if(spanparent) {
			parent = getChildNode(spanparent, "A");
		}
	} else if(anode.parentNode.className == "branch") {
		var leafSpan = anode.parentNode.parentNode;
		if(leafSpan != null) {
			var spanparent = leafSpan.previousSibling;
			if(spanparent) {
				parent = getChildNode(spanparent, "A");
			}
		}
	}
	return parent;
}

/**
 * Returns the next sibling element
 */
function getNextSibling(anode) {
	var sib;
	if(anode.parentNode.className == "leaf") {
		sib = anode.nextSibling.nextSibling;
	} else {
		sib = anode.parentNode.nextSibling.nextSibling;
	}
	var foundSibling = null;
	if(sib) {
		if(sib.tagName == "SPAN") {
			foundSibling = getChildNode(sib, "A");
		} else {
			// sib.tagName == "IMG"
			// Anchor node
			foundSibling = getSibling(sib, "A");
		}
	}
	return foundSibling;
}

/**
 * Returns the previous sibling element
 */
function getPreviousSibling(anode) {
	var sib;
	var foundSibling = null;
	if(anode.parentNode.className == "leaf") {
		sib = anode.previousSibling.previousSibling;
	} else {
		sib = anode.parentNode.previousSibling;
		if(sib) {
			sib = sib.previousSibling;
		}
	}
	if(sib) {
		if(sib.tagName == "SPAN") {
			if(sib.className == "leaf") {
				foundSibling = getChildNode(sib.previousSibling, "A");
			} else {
				foundSibling = getChildNode(sib, "A");
			}
		} else {
			// Anchor node
			foundSibling = getPreSibling(sib, "A");
		}
	}
	return foundSibling;
}

function getTarget(e) {
	var target;
  	if (isMozilla)
  		target = e.target;
  	else if (isIE)
   		target = window.event.srcElement;

	if(target.tagName != "A") {
		if(oldActive !=null) {
			target = oldActive;
		}
	}
	return target;
}

/**
 * Scrolls the page to show the specified element
 */
function scrollIntoView(node){
	var scroll = getVerticalScroll(node);
	if (scroll != 0)
		window.scrollBy(0, scroll);
}

/**
 * Scrolls the page to show the specified element
 */
function getVerticalScroll(node){
	var nodeTop = node.offsetTop;
	var nodeBottom = nodeTop + 32;
	var pageTop = 0;
	var pageBottom = 0;
	
	if (isIE) {
		pageTop = document.body.scrollTop; 
		pageBottom = pageTop + document.body.clientHeight;
	
	} else if (isMozilla){
		pageTop = window.pageYOffset;
		pageBottom = pageTop + window.innerHeight - node.offsetHeight;
	}
	
	var scroll = 0;
	if (nodeTop >= pageTop ) {
		if (nodeBottom <= pageBottom) {
			scroll = 0; // already in view
		} else {
			scroll = nodeBottom - pageBottom;
		}
	} else {
		scroll = nodeTop - pageTop;
	}
	
	return scroll;
}

/**
* Check if this is a collapsed folder node.
*/
function isCollapsedFolder(node) {
	if(node.parentNode.className=="branch") {
		var imgNode;
		imgNode = getChildNode(node.parentNode, "IMG");
		if(imgNode.src.indexOf('plus.gif')>-1) {
			return true;
		}
	}
	return false;
}

/**
* Check if this is an expanded folder node.
*/
function isExpandedFolder(node){
	if(node.parentNode.className=="branch") {
		var imgNode;
		imgNode = getChildNode(node.parentNode, "IMG");
		if(imgNode.src.indexOf('minus.gif')>-1) {
			return true;
		}
	}
	return false;
}

/**
 * Returns the previous sibling node with specified tag
 */
function getPreSibling(node, tag) {
	var sibling = node.previousSibling;
	if(sibling) {
		if(sibling.tagName == tag) {
			return sibling;
		} else {
			return getSibling(sibling, tag);
		}
	} else {
		return null;
	}
}

/**
 * Returns the next sibling node with specified tag
 */ 
function getSibling(node, tag) {
	var sibling = node.nextSibling;
	if(sibling) {
		if(sibling.tagName == tag) {
			return sibling;
		} else {
			return getSibling(sibling, tag);
		}
	} else {
		return null;
	}
}

/**
 * Returns the child node with specified tag
 */
function getChildNode(parent, childTag){
	var list = parent.childNodes;
	if (list == null) return null;
	for (var i=0; i<list.length; i++) {
		if (list.item(i).tagName == childTag)
			return list.item(i);
	}
	return null;
}

/**
 * Returns the descendat node with specified tag (depth-first searches)
 */
function getDescendantNode(parent, childTag){	
	if (parent.tagName == childTag)
		return parent;
		
	var list = parent.childNodes;
	if (list == null) return null;
	for (var i=0; i<list.length; i++) {
		var child = list.item(i);
		if(child.tagName == childTag)
			return child;
		
		child = getDescendantNode(child, childTag);
		if (child != null)
			return child;
	}
	return null;
}

function getBaseID(node) {
	var baseID = node.id.substr(1, node.id.length);
	return baseID;
}

// listen for events
if (isMozilla) {
  document.addEventListener('keydown', keyDownHandler, true);
} else if (isIE){
  document.onkeydown = keyDownHandler;
}

